routes/web.php
<?php

use Illuminate\Support\Facades\Route;


Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->middleware('auth')->name('home');

Route::prefix('admin')
    ->as('admin.')
    ->middleware(['auth', 'account:admin'])
    ->group(function () {

        Route::get('/', [App\Http\Controllers\Admin\MainController::class, 'index'])->name('home');

        Route::post('/users/{user}/deactivate', [App\Http\Controllers\Admin\UserController::class, 'deactivate'])->name('user.deactivate');
        Route::post('/users/{user}/activate', [App\Http\Controllers\Admin\UserController::class, 'activate'])->name('user.activate');
        Route::resource('users', App\Http\Controllers\Admin\UserController::class)->only([
            'index', 'show', 'edit', 'update', 'destroy'
        ]);
        Route::resource('books', App\Http\Controllers\Admin\BookController::class)->only([
            'index', 'create', 'store', 'show', 'edit', 'update', 'destroy'
        ]);

        Route::resource('booking', App\Http\Controllers\Admin\BookBookingController::class)->only([
            'index'
        ]);
        Route::resource('rentals', App\Http\Controllers\Admin\BookRentalController::class)->only([
            'index', 'edit', 'update', 'destroy'
        ]);

});

Route::prefix('profile')
    ->as('profile.')
    ->middleware(['auth', 'account:user'])
    ->group(function () {

        Route::get('/', [App\Http\Controllers\Profile\ProfileController::class, 'index'])->name('home');

        Route::get('/search', [App\Http\Controllers\Profile\SearchController::class, 'index'])->name('search');

        Route::prefix('my')->as('user.')->group(function () {
            Route::get('/', [App\Http\Controllers\Profile\ProfileController::class, 'show'])->name('show');
            Route::get('/edit', [App\Http\Controllers\Profile\ProfileController::class, 'edit'])->name('edit');
            Route::post('/update', [App\Http\Controllers\Profile\ProfileController::class, 'update'])->name('update');
        });

        Route::prefix('books')->as('books.')->group(function () {
            Route::get('/', [App\Http\Controllers\Profile\BookController::class, 'index'])->name('index');
            Route::get('{book}', [App\Http\Controllers\Profile\BookController::class, 'show'])->name('show');
            Route::post('{book}/comments', [App\Http\Controllers\Profile\CommentController::class, 'store'])->name('comments.store');
            Route::delete('{book}/comments/{comment}', [App\Http\Controllers\Profile\CommentController::class, 'destroy'])->name('comments.destroy');
        });

        Route::prefix('booking')->as('booking.')->group(function () {
            Route::get('/', [App\Http\Controllers\Profile\BookBookingController::class, 'index'])->name('index');
            Route::post('{book}/booking', [App\Http\Controllers\Profile\BookBookingController::class, 'store'])->name('store');
            Route::delete('{book}/booking/{booking}', [App\Http\Controllers\Profile\BookBookingController::class, 'destroy'])->name('destroy');
        });

        Route::prefix('rentals')->as('rentals.')->group(function () {
            Route::get('/', [App\Http\Controllers\Profile\BookRentalController::class, 'index'])->name('index');
            Route::post('{book}/rental', [App\Http\Controllers\Profile\BookRentalController::class, 'store'])->name('store');
        });

        Route::get('/logs', [App\Http\Controllers\Profile\LogsController::class, 'index'])->name('logs');
});

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'role_id',
        'first_name',
        'last_name',
        'middle_name',
        'email',
        'password',
        'status'
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function role(): BelongsTo
    {
        return $this->belongsTo(Role::class, 'role_id');
    }

    public function logs(): HasMany
    {
        return $this->hasMany(Log::class, 'user_id', 'id');
    }

    public function getFullNameAttribute()
    {
        return preg_replace('/\s+/', ' ',$this->first_name.' '.$this->last_name.' '.$this->middle_name);
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\UserUpdateRequest;
use App\Models\Role;
use App\Models\User;
use App\Services\UserService;

class UserController extends Controller
{
    public function index()
    {
        $users = User::with('role')->get();
        return view('admin.users.index', ['users' => $users]);
    }

    public function show(User $user)
    {
        return view('admin.users.show', ['user' => $user]);
    }

    public function edit(User $user)
    {
        $roles = Role::get();
        return view('admin.users.edit', ['user' => $user, 'roles' => $roles]);
    }

    public function update(UserUpdateRequest $request, User $user, UserService $userService)
    {
        $userService->update($request, $user);

        return redirect()->route('admin.users.show', $user);
    }

    public function destroy(User $user, UserService $userService)
    {
        $userService->remove($user);

        return redirect()->route('admin.users.index');
    }

    public function activate(User $user, UserService $userService)
    {
        $userService->activate($user);
        return redirect()->route('admin.users.edit', $user);
    }

    public function deactivate(User $user, UserService $userService)
    {
        $userService->deactivate($user);
        return redirect()->route('admin.users.edit', $user);
    }
}

resources/views/admin/users/edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">

        @include('admin.components.menu')


        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">Профиль</div>

                    <div class="card-body">
                        <form method="POST" action="{{ route('admin.users.update', $user->id) }}">
                            @csrf
                            @method('PUT')

                            <div class="row mb-3">
                                <label for="name" class="col-md-4 col-form-label text-md-end">Роль</label>

                                <div class="col-md-6">
                                    <select name="role" id="role" class="form-control @error('role') is-invalid @enderror" required>
                                        @forelse ($roles as $role)
                                            <option value="{{ $role->id }}" {{ $role->id == $user->role->id ? 'selected' : '' }}>{{ $role->name }}</option>
                                        @empty
                                            <option selected disabled>Пусто</option>
                                        @endforelse
                                    </select>
                                </div>

                                @error('role')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>

                            <div class="row mb-3">
                                <label for="first_name" class="col-md-4 col-form-label text-md-end">{{ __('FirstName') }}</label>

                                <div class="col-md-6">
                                    <input id="first_name" type="text" class="form-control @error('first_name') is-invalid @enderror" name="first_name" value="{{ $user->first_name }}" required autocomplete="first_name" autofocus>

                                    @error('first_name')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>
                            <div class="row mb-3">
                                <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('LastName') }}</label>

                                <div class="col-md-6">
                                    <input id="last_name" type="text" class="form-control @error('last_name') is-invalid @enderror" name="last_name" value="{{ $user->last_name }}" required autocomplete="last_name" autofocus>

                                    @error('last_name')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>
                            <div class="row mb-3">
                                <label for="middle_name" class="col-md-4 col-form-label text-md-end">{{ __('MiddleName') }}</label>

                                <div class="col-md-6">
                                    <input id="middle_name" type="text" class="form-control @error('middle_name') is-invalid @enderror" name="middle_name" value="{{ $user->middle_name }}" autocomplete="middle_name" autofocus>

                                    @error('middle_name')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="row mb-3">
                                <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('Email') }}</label>

                                <div class="col-md-6">
                                    <input id="name" type="text" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ $user->email }}" required autocomplete="name" autofocus>
                                </div>

                                @error('email')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>

                            <div class="row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        Изменить профиль
                                    </button>
                                </div>
                            </div>
                        </form>

                        <hr>
                        <br>
                        <div class="row">
                            @if($user->status === 'deactivated')
                                <div class="col-lg-6">
                                    <form method="POST" action="{{ route('admin.user.activate', $user) }}">
                                        @csrf

                                        <div class="col-md-12">
                                            <button type="submit" class="btn btn-warning">
                                                Разблокировать пользователя
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            @endif
                            @if($user->status === 'active')
                                <div class="col-lg-6">
                                    <form method="POST" action="{{ route('admin.user.deactivate', $user) }}">
                                        @csrf

                                        <div class="col-md-12">
                                            <button type="submit" class="btn btn-warning">
                                                Заблокировать пользователя
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection

resources/views/admin/users/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">

        @include('admin.components.menu')



        <table class="table">
            <thead>
                <tr>
                    <th scope="col">#id</th>
                    <th scope="col">Имя</th>
                    <th scope="col">Email</th>
                    <th scope="col">Роль</th>
                    <th scope="col">Действия</th>
                </tr>
            </thead>
            <tbody>
                @forelse ($users as $user)
                    <tr>
                        <th scope="row">{{ $user->id }}</th>
                        <td>{{ $user->full_name }}</td>
                        <td>{{ $user->email }}</td>
                        <td>{{ $user->role->name }}</td>
                        <td>
                            <a href="{{ route('admin.users.show', $user->id) }}" class="btn btn-success">Просмотр</a>
                            <a href="{{ route('admin.users.edit', $user->id) }}" class="btn btn-primary">Редактирование</a>
                            <form action="{{ route('admin.users.destroy', $user->id) }}" method="POST">
                                @csrf
                                @method('DELETE')
                                <button class="btn btn-danger" type="submit">Удалить</button>
                            </form>
                        </td>
                    </tr>
                @empty
                    <p>Пусто</p>
                @endforelse
            </tbody>
        </table>

    </div>

@endsection

resources/views/admin/users/show.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">

        @include('admin.components.menu')

        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">Профиль</div>

                    <div class="card-body">

                        <div class="row mb-3">
                            <label for="name" class="col-md-4 col-form-label text-md-end">Роль</label>

                            <div class="col-md-6">
                                <input id="name" type="text" disabled class="form-control" name="role" value="{{ $user->role->name }}" required autocomplete="name" autofocus>
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="first_name" class="col-md-4 col-form-label text-md-end">{{ __('FirstName') }}</label>

                            <div class="col-md-6">
                                <input id="first_name" type="text" disabled class="form-control" name="first_name" value="{{ $user->first_name }}">
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="last_name" class="col-md-4 col-form-label text-md-end">{{ __('LastName') }}</label>

                            <div class="col-md-6">
                                <input id="last_name" type="text" disabled class="form-control" name="last_name" value="{{ $user->last_name }}">
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="middle_name" class="col-md-4 col-form-label text-md-end">{{ __('MiddleName') }}</label>

                            <div class="col-md-6">
                                <input id="middle_name" type="text" disabled class="form-control" name="middle_name" value="{{ $user->middle_name }}">
                            </div>
                        </div>
                        <div class="row mb-3">
                            <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('Email') }}</label>

                            <div class="col-md-6">
                                <input id="name" type="text" disabled class="form-control" name="email" value="{{ $user->email }}" required autocomplete="name" autofocus>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <ul class="list-group mb-4 mt-4">
            @forelse($user->logs as $log)
                <li class="list-group-item">
                    <strong>{{ $log->massage ?? '' }}</strong><br>
                    <div>
                        Книга #{{ $log->book->id ?? '' }}<br>
                        {{ $log->book->title ?? '' }}<br>
                        {{ $log->book->isbn ?? '' }}
                    </div>
                </li>
            @empty
                <li class="list-group-item">Нет событий</li>
            @endforelse
        </ul>

    </div>

@endsection